<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: TcpSocket.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_tcp_socket_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">TcpSocket.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_tcp_socket_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="preprocessor">#ifndef TCPSOCKET_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define TCPSOCKET_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_connected_socket_8h.html">ConnectedSocket.h</a>&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span>core {</div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_tcp_socket.html">   25</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_tcp_socket.html">TcpSocket</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_connected_socket.html">ConnectedSocket</a> {</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;  <a class="code" href="classflair_1_1core_1_1_tcp_socket.html">TcpSocket</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_object.html">Object</a> *parent, <span class="keyword">const</span> std::string name,</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;            <span class="keywordtype">bool</span> blockOnSend = <span class="keyword">false</span>, <span class="keywordtype">bool</span> blockOnReceive = <span class="keyword">true</span>);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;  ~<a class="code" href="classflair_1_1core_1_1_tcp_socket.html">TcpSocket</a>();</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_tcp_socket.html#a7eaffe48d70e5119182bdb5846c6889d">Listen</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> port, <span class="keyword">const</span> std::string localAddress = <span class="stringliteral">&quot;ANY&quot;</span>);</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;  <a class="code" href="classflair_1_1core_1_1_tcp_socket.html">TcpSocket</a> *<a class="code" href="classflair_1_1core_1_1_tcp_socket.html#af3ea9a03fb31fe36b604060e9386d617">Accept</a>(</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;      <a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> timeout = TIME_INFINITE);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classflair_1_1core_1_1_tcp_socket.html#aea4dd2ff49fc3e2ba8a3afcccedbc4af">Connect</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> distantPort, <span class="keyword">const</span> std::string distantAddress,</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;               <a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> timeout = TIME_INFINITE);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;  ssize_t <a class="code" href="classflair_1_1core_1_1_tcp_socket.html#a35141127ad1e1fd921f5ca91e2341674">SendMessage</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *message, <span class="keywordtype">size_t</span> message_len, <a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> timeout = TIME_INFINITE);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;  ssize_t <a class="code" href="classflair_1_1core_1_1_tcp_socket.html#a843ce6bee190e7840ca5554654ed580d">RecvMessage</a>(<span class="keywordtype">char</span> *buf, <span class="keywordtype">size_t</span> buf_len, <a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> timeout = TIME_INFINITE);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;  uint16_t <a class="code" href="classflair_1_1core_1_1_tcp_socket.html#a94921895eb0b474e967d611d78d630e2">NetworkToHost16</a>(uint16_t data);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;  uint16_t HostToNetwork16(uint16_t data);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;  uint32_t NetworkToHost32(uint32_t data);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;  uint32_t HostToNetwork32(uint32_t data);</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="keywordtype">int</span> socket; <span class="comment">// socket file descriptor</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="keywordtype">bool</span> blockOnSend;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;  <span class="keywordtype">bool</span> blockOnReceive;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  <span class="keywordtype">bool</span> isConnected;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;  <span class="keywordtype">bool</span> isListening;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> distantPort;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;  std::string distantAddress;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;  <span class="keywordtype">char</span> *sendRingBuffer, *recvRingBuffer;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;};</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;} <span class="comment">// end namespace core</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">#endif // TCPSOCKET_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1_connected_socket_html"><div class="ttname"><a href="classflair_1_1core_1_1_connected_socket.html">flair::core::ConnectedSocket</a></div><div class="ttdoc">Interface class encapsulating a connected socket. Preserves packets order and guaranty delivery...</div><div class="ttdef"><b>Definition:</b> ConnectedSocket.h:27</div></div>
<div class="ttc" id="classflair_1_1core_1_1_object_html"><div class="ttname"><a href="classflair_1_1core_1_1_object.html">flair::core::Object</a></div><div class="ttdoc">Base class for all Framework&#39;s classes. </div><div class="ttdef"><b>Definition:</b> Object.h:83</div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="namespaceflair_1_1core_html_acc0fa041e08ecf73b2d1d723c339a736"><div class="ttname"><a href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">flair::core::Time</a></div><div class="ttdeci">unsigned long long Time</div><div class="ttdoc">Time definition, in ns. </div><div class="ttdef"><b>Definition:</b> Object.h:55</div></div>
<div class="ttc" id="classflair_1_1core_1_1_tcp_socket_html"><div class="ttname"><a href="classflair_1_1core_1_1_tcp_socket.html">flair::core::TcpSocket</a></div><div class="ttdoc">Class encapsulating a TCP socket. </div><div class="ttdef"><b>Definition:</b> TcpSocket.h:25</div></div>
<div class="ttc" id="_connected_socket_8h_html"><div class="ttname"><a href="_connected_socket_8h.html">ConnectedSocket.h</a></div><div class="ttdoc">Class defining a socket working in connected mode. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_tcp_socket_html_a7eaffe48d70e5119182bdb5846c6889d"><div class="ttname"><a href="classflair_1_1core_1_1_tcp_socket.html#a7eaffe48d70e5119182bdb5846c6889d">flair::core::TcpSocket::Listen</a></div><div class="ttdeci">void Listen(const unsigned int port, const std::string localAddress=&quot;ANY&quot;)</div><div class="ttdoc">Returns a socket which listens on a specific port/address. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_tcp_socket_html_a94921895eb0b474e967d611d78d630e2"><div class="ttname"><a href="classflair_1_1core_1_1_tcp_socket.html#a94921895eb0b474e967d611d78d630e2">flair::core::TcpSocket::NetworkToHost16</a></div><div class="ttdeci">uint16_t NetworkToHost16(uint16_t data)</div><div class="ttdoc">! See Socket.h for a more generic implementation of network/host endianness </div></div>
<div class="ttc" id="classflair_1_1core_1_1_tcp_socket_html_a843ce6bee190e7840ca5554654ed580d"><div class="ttname"><a href="classflair_1_1core_1_1_tcp_socket.html#a843ce6bee190e7840ca5554654ed580d">flair::core::TcpSocket::RecvMessage</a></div><div class="ttdeci">ssize_t RecvMessage(char *buf, size_t buf_len, Time timeout=TIME_INFINITE)</div><div class="ttdoc">Receive a message. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_tcp_socket_html_aea4dd2ff49fc3e2ba8a3afcccedbc4af"><div class="ttname"><a href="classflair_1_1core_1_1_tcp_socket.html#aea4dd2ff49fc3e2ba8a3afcccedbc4af">flair::core::TcpSocket::Connect</a></div><div class="ttdeci">bool Connect(const unsigned int distantPort, const std::string distantAddress, Time timeout=TIME_INFINITE)</div><div class="ttdoc">Returns a socket connected to a distant host. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_tcp_socket_html_af3ea9a03fb31fe36b604060e9386d617"><div class="ttname"><a href="classflair_1_1core_1_1_tcp_socket.html#af3ea9a03fb31fe36b604060e9386d617">flair::core::TcpSocket::Accept</a></div><div class="ttdeci">TcpSocket * Accept(Time timeout=TIME_INFINITE)</div><div class="ttdoc">Returns a socket on a new incoming connexion. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_tcp_socket_html_a35141127ad1e1fd921f5ca91e2341674"><div class="ttname"><a href="classflair_1_1core_1_1_tcp_socket.html#a35141127ad1e1fd921f5ca91e2341674">flair::core::TcpSocket::SendMessage</a></div><div class="ttdeci">ssize_t SendMessage(const char *message, size_t message_len, Time timeout=TIME_INFINITE)</div><div class="ttdoc">Send a message waiting up to timeout ns. </div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_97265977dbbd48c696782ccac102bad5.html">FlairCore</a></li><li class="navelem"><a class="el" href="dir_6c198461db290ac9abcdd44184573216.html">src</a></li><li class="navelem"><a class="el" href="_tcp_socket_8h.html">TcpSocket.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
